---
tags:
  - Python
  - Qt
  - PyQt
  - Audio
  - Media
  - Pygame
---
Wobuzz is an open source audio player made by [[../The Wobbler|The Wobbler]]. Wobuzz is written in Python using the [Qt](https://www.qt.io/) framework and [Pygame](https://pygame.org/). Wobuzz uses the dedicated [[WOBUZZM3U|WOBUZZM3U playlist file format]].

# UI
The UI is inspired by [Audacious](https://audacious-media-player.org/), which is also using the Qt framework.


# Library
The default library path is `~/.wobuzz`, you can change the path in the settings, but for now, (v0.1a3) Wobuzz is not able to copy the content over to the new directory.
If you want to move the library, you have to follow these steps:  

* Move the folder manually (and replace the paths in the playlists)
* Start Wobuzz
* Change the path in the settings
* Restart Wobuzz (or else things will break)

## Loading & Importing
If you want to open a track or a playlist, there are 2 options. You can load or import. Loading does nothing special. Importing however lets you choose if you want to copy the audio files into the Wobuzz library, move them or create symlinks to the files.